source("functions.R")

shinyServer(
  function(input, output) {
    output$excl <- renderUI({
        if(input$excl.yn){
          sliderInput("excl.viol", 
                      label = "How big is the exclusion restriction violation?",
                      min = 0, max = 10, value = 0, ticks = F)
        }
      })
    output$excl2 <- renderUI({
      if(input$excl.yn){
        checkboxInput("excl.viol.dir",
                      label = "Is the instrument positively correlated with the outcome?")
      }
    })
    
    
    datas <- eventReactive(input$sim.data, {
      simulated <- sim.all(nsims = input$nsims, 
                           nobs = input$nobs,
                           strength = exp(as.numeric(input$strength)),
                           ate = 3,
                           excl.viol = ifelse(input$excl.yn, input$excl.viol, 0),
                           direction = ifelse(input$excl.yn, input$excl.viol.dir, T))
      all.te(simulated)
    })
    
    
    output$estfx <- renderPlot({
      graphit(datas(),
              ate = 3,
              tolerance = 20)
    }, height = 700, width = 1000, res = 130)
  }
  )